org.apache.hc.client5.http.impl.nio

## Class PoolingAsyncClientConnectionManagerBuilder

- java.lang.Object
- - org.apache.hc.client5.http.impl.nio.PoolingAsyncClientConnectionManagerBuilder

-     public class PoolingAsyncClientConnectionManagerBuilder
      extends Object

  Builder for `PoolingAsyncClientConnectionManager` instances.

  When a particular component is not explicitly set this class will use its default implementation. System properties will be taken into account when configuring the default implementations when `useSystemProperties()` method is called prior to calling `build()`.

  - ssl.TrustManagerFactory.algorithm
  - javax.net.ssl.trustStoreType
  - javax.net.ssl.trustStore
  - javax.net.ssl.trustStoreProvider
  - javax.net.ssl.trustStorePassword
  - ssl.KeyManagerFactory.algorithm
  - javax.net.ssl.keyStoreType
  - javax.net.ssl.keyStore
  - javax.net.ssl.keyStoreProvider
  - javax.net.ssl.keyStorePassword
  - https.protocols
  - https.cipherSuites
  Since:
    5.0

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `PoolingAsyncClientConnectionManager` | `build()`
    `static PoolingAsyncClientConnectionManagerBuilder` | `create()`
    `PoolingAsyncClientConnectionManagerBuilder` | `setConnectionTimeToLive(org.apache.hc.core5.util.TimeValue timeToLive)` Sets maximum time to live for persistent connections
    `PoolingAsyncClientConnectionManagerBuilder` | `setConnPoolPolicy(org.apache.hc.core5.pool.PoolReusePolicy poolReusePolicy)` Assigns `PoolReusePolicy` value.
    `PoolingAsyncClientConnectionManagerBuilder` | `setDnsResolver(DnsResolver dnsResolver)` Assigns `DnsResolver` instance.
    `PoolingAsyncClientConnectionManagerBuilder` | `setMaxConnPerRoute(int maxConnPerRoute)` Assigns maximum connection per route value.
    `PoolingAsyncClientConnectionManagerBuilder` | `setMaxConnTotal(int maxConnTotal)` Assigns maximum total connection value.
    `PoolingAsyncClientConnectionManagerBuilder` | `setPoolConcurrencyPolicy(org.apache.hc.core5.pool.PoolConcurrencyPolicy poolConcurrencyPolicy)` Assigns `PoolConcurrencyPolicy` value.
    `PoolingAsyncClientConnectionManagerBuilder` | `setSchemePortResolver(SchemePortResolver schemePortResolver)` Assigns `SchemePortResolver` instance.
    `PoolingAsyncClientConnectionManagerBuilder` | `setTlsStrategy(org.apache.hc.core5.http.nio.ssl.TlsStrategy tlsStrategy)` Assigns `TlsStrategy` instance for TLS connections.
    `PoolingAsyncClientConnectionManagerBuilder` | `setValidateAfterInactivity(org.apache.hc.core5.util.TimeValue validateAfterInactivity)` Sets period after inactivity after which persistent connections must be checked to ensure they are still valid.
    `PoolingAsyncClientConnectionManagerBuilder` | `useSystemProperties()` Use system properties when creating and configuring default implementations.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### create

          public static PoolingAsyncClientConnectionManagerBuilder create()

    - #### setTlsStrategy

          public final PoolingAsyncClientConnectionManagerBuilder setTlsStrategy(org.apache.hc.core5.http.nio.ssl.TlsStrategy tlsStrategy)

      Assigns `TlsStrategy` instance for TLS connections.

    - #### setDnsResolver

          public final PoolingAsyncClientConnectionManagerBuilder setDnsResolver(DnsResolver dnsResolver)

      Assigns `DnsResolver` instance.

    - #### setSchemePortResolver

          public final PoolingAsyncClientConnectionManagerBuilder setSchemePortResolver(SchemePortResolver schemePortResolver)

      Assigns `SchemePortResolver` instance.

    - #### setPoolConcurrencyPolicy

          public final PoolingAsyncClientConnectionManagerBuilder setPoolConcurrencyPolicy(org.apache.hc.core5.pool.PoolConcurrencyPolicy poolConcurrencyPolicy)

      Assigns `PoolConcurrencyPolicy` value.

    - #### setConnPoolPolicy

          public final PoolingAsyncClientConnectionManagerBuilder setConnPoolPolicy(org.apache.hc.core5.pool.PoolReusePolicy poolReusePolicy)

      Assigns `PoolReusePolicy` value.

    - #### setMaxConnTotal

          public final PoolingAsyncClientConnectionManagerBuilder setMaxConnTotal(int maxConnTotal)

      Assigns maximum total connection value.

    - #### setMaxConnPerRoute

          public final PoolingAsyncClientConnectionManagerBuilder setMaxConnPerRoute(int maxConnPerRoute)

      Assigns maximum connection per route value.

    - #### setConnectionTimeToLive

          public final PoolingAsyncClientConnectionManagerBuilder setConnectionTimeToLive(org.apache.hc.core5.util.TimeValue timeToLive)

      Sets maximum time to live for persistent connections

    - #### setValidateAfterInactivity

          public final PoolingAsyncClientConnectionManagerBuilder setValidateAfterInactivity(org.apache.hc.core5.util.TimeValue validateAfterInactivity)

      Sets period after inactivity after which persistent connections must be checked to ensure they are still valid.
      See Also:
        `BHttpConnection.isStale()`

    - #### useSystemProperties

          public final PoolingAsyncClientConnectionManagerBuilder useSystemProperties()

      Use system properties when creating and configuring default implementations.

    - #### build

          public PoolingAsyncClientConnectionManager build()

Copyright © 1999–2022 The Apache Software Foundation. All rights reserved.